
// sprtf.cxx

#pragma warning( disable:4267 ) // conv. 'size_t' to 'unsigned int', possible loss rubbish
//#ifdef HAVE_CONFIG_H
//#  include <config.h>
//#endif

//#include <simgear/compiler.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "sprtf.hxx"

#define DBGFILE   "tempprt.txt"
//#define  MXIO     256
#define  MXIO     1024
int gb_AddCrLf = 0;
int gb_DnFile = 0;
FILE * dbg_file = 0;
int g_bWriteFile = 1;

void dbg_open( void )
{
   if(dbg_file == 0) {
      dbg_file = fopen(DBGFILE, "wb");
   }
   gb_DnFile = 1;
}

void dbg_close( void )
{
   if(dbg_file)
      fclose(dbg_file);
   dbg_file = 0;
}


void oi( char * ps )
{
   int len = strlen(ps);

   if( len && ( gb_DnFile == 0 ) ) {
      dbg_open();
   }

   if(len && dbg_file) {
      // write to file buf, count, len, FILE *
      int wlen = fwrite( ps, 1, len, dbg_file );

      fflush(dbg_file);
      if( wlen != len ) {
         printf("Warning: Write to DEBUG file failed!\n" );
         dbg_close();
      }
   }

   // printf(ps);
}

void	prt( char * lps )
{
   static char	_s_prt_buf[MXIO + 32]; // format to buffer
	char * lpb;
	int		i, j, k;
	char	c, d;
   i = 0;
   if(lps)
      i = strlen(lps);

	if( i ) {
		k = 0;
		d = 0;
		lpb = _s_prt_buf;
		for( j = 0; j < i; j++ ) {
			c = lps[j];
			if( c == 0x0d ) {
				if( (j+1) < i ) {
					if( lps[j+1] != 0x0a ) {
						lpb[k++] = c;
						c = 0x0a;
					}
				} else {
					lpb[k++] = c;
					c = 0x0a;
				}
			} else if( c == 0x0a ) {
				if( d != 0x0d ) {
					lpb[k++] = 0x0d;
				}
			}
			lpb[k++] = c;
			d = c;
			if( k >= MXIO ) {
				lpb[k] = 0;
				oi( lpb );
				k = 0;
			}
		}	// for length of string
		if( k ) {
			if(( gb_AddCrLf ) &&
				( d != 0x0a  ) ) { // add Cr/Lf pair
				lpb[k++] = 0x0d;
				lpb[k++] = 0x0a;
				lpb[k] = 0;
			}
			lpb[k] = 0;
			oi( lpb );
		}
	}
}

int _cdecl sprtf( char * lpf, ... )
{
   static char _s_sprtfbuf[1024];
   char * lpb = &_s_sprtfbuf[0];
   int   i;
   va_list arglist;
   va_start(arglist, lpf);
   i = vsprintf( lpb, lpf, arglist );
   va_end(arglist);
   //printf(lpb);
   prt(lpb);
   return i;
}

int _cdecl chkme( char * lpf, ... )
{
   static char _s_chkmebuf[1024];
   char * lpb = &_s_chkmebuf[0];
   int   i;
   va_list arglist;
   va_start(arglist, lpf);
   i = vsprintf( lpb, lpf, arglist );
   va_end(arglist);
   printf(lpb);
   prt(lpb);
   //sprtf(lpb);
   if(( lpb[0] == 'C' ) && ( lpb[1] == ':' )) {
      printf( "CRITICAL ERROR - Aborting ...\n" );
      exit(-1);
   }

   return i;
}

// sprtf.cxx
